﻿' Fig. 9.2: Account.vb
' Account class for maintaining a bank account balance.
Public Class Account
    Private BalanceDecimal As Decimal ' instance variable stores the balance

    ' constructor initializes balanceValue
    Public Sub New(Optional initialBalanceDecimal As Decimal = 0D)
        ' if initialBalance is less than 0, throw an exception
        If initialBalanceDecimal < 0D Then
            Throw New ArgumentOutOfRangeException(
               "Initial balance must be greater than or equal to 0.")
        End If

        BalanceDecimal = initialBalanceDecimal ' initialize balanceValue
    End Sub ' New

    ' deposit money to the account
    Public Sub Deposit(inDepositAmountDecimal As Decimal)
        ' if depositAmount is less than or equal to 0, throw an exception
        If inDepositAmountDecimal <= 0D Then
            Throw New ArgumentOutOfRangeException(
               "Deposit amount must be positive.")
        End If

        BalanceDecimal += inDepositAmountDecimal ' add depositAmount to balanceValue
    End Sub ' Deposit

    ' withdraw money from the account
    Public Sub Withdraw(inWithdrawalAmountDecimal As Decimal)
        ' if withdrawalAmount is greater than Balance, throw an exception
        If inWithdrawalAmountDecimal > Balance Then ' invokes lines 45-47
            Throw New ArgumentOutOfRangeException(
               "Withdrawal amount must be less than or equal to balance.")
        ElseIf inWithdrawalAmountDecimal <= 0D Then
            Throw New ArgumentOutOfRangeException(
               "Withrawal amount must be positive.")
        End If

        ' subtract withdrawalAmount from balanceValue
        BalanceDecimal -= inWithdrawalAmountDecimal
    End Sub ' Withdraw

    ' return the current balance
    Public ReadOnly Property Balance As Decimal
        Get
            Return BalanceDecimal
        End Get
    End Property ' Balance
End Class ' Account
