﻿
Public Class AccountTest
    Private myAccount As New Account() ' create an Account object

    ' display the initial account balance when program executes
    Private Sub AccountTest_Load(sender As Object,
       e As EventArgs) Handles MyBase.Load

        accountBalanceValueLabel.Text =
           String.Format("{0:C}", myAccount.Balance)
    End Sub ' AccountTest_Load

    ' process a deposit
    Private Sub depositButton_Click(sender As Object,
       e As EventArgs) Handles depositButton.Click

        Try
            ' get deposit amount
            Dim DepositAmountDecimal As Decimal =
               Convert.ToDecimal(inputTextBox.Text)
            myAccount.Deposit(DepositAmountDecimal) ' make the deposit
            accountBalanceValueLabel.Text =
               String.Format("{0:C}", myAccount.Balance)
        Catch ex As ArgumentOutOfRangeException
            MessageBox.Show("Deposit amount must be positive.",
               "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

        inputTextBox.Clear() ' clear the inputTextBox
        inputTextBox.Focus() ' allow user to type in the inputTextBox
    End Sub ' depositButton_Click

    ' process a withdrawal
    Private Sub withdrawButton_Click(sender As Object,
       e As EventArgs) Handles withdrawButton.Click

        Try
            ' get withdrawal amount
            Dim WithdrawalAmountDecimal As Decimal =
               Convert.ToDecimal(inputTextBox.Text)
            myAccount.Withdraw(WithdrawalAmountDecimal) ' make the withdrawal
            accountBalanceValueLabel.Text =
               String.Format("{0:C}", myAccount.Balance)
        Catch ex As ArgumentOutOfRangeException
            MessageBox.Show("Withdrawal amount must be greater than 0 " &
               "and less than or equal to the account balance.",
               "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

        inputTextBox.Clear() ' clear the inputTextBox
        inputTextBox.Focus() ' allow user to type in the inputTextBox
    End Sub ' withdrawButton_Click
End Class ' AccountTest
